import type { MiddlewareObj } from '@middy/core';
import type { Static, TSchema } from '@sinclair/typebox';
import type { ValueError } from '@sinclair/typebox/compiler';
import type { APIGatewayProxyEventV2, APIGatewayProxyStructuredResultV2, Context } from 'aws-lambda';
export declare class ValidationFailedError extends Error {
    readonly errors: ValueError[];
    constructor(errors: ValueError[]);
}
export declare const validateInput: <Schema extends TSchema>(schema: Schema, mapInput?: (e: APIGatewayProxyEventV2) => unknown) => MiddlewareObj<APIGatewayProxyEventV2, APIGatewayProxyStructuredResultV2, Error, Context & ValidInput<Schema>>;
export type ValidInput<Schema extends TSchema> = {
    validInput: Static<Schema>;
};
