export const addVersionHeader = (version) => {
    const setVersionHeader = async (req) => {
        if (req.response === null)
            return;
        req.response = {
            ...req.response,
            headers: {
                ...(req.response.headers ?? {}),
                'x-backend-version': version,
            },
        };
    };
    return {
        after: setVersionHeader,
        onError: setVersionHeader,
    };
};
